/* roadConstruct.cpp uses the trapezoidal method to find the volume 
 *  of dirt that must be removed to construct a road through a hill.
 *
 *  Input:  the length of roadway through the hill,
 *          the width of the roadway
 *  Output: the approximate volume of dirt removed
 ****************************************************************/

#include <iostream>             // cin, cout. >>, <<
using namespace std;

double trapezoidalArea(int n, double totalLength);

int main()
{

   cout << "Enter the length of roadway through the hill: ";
   double roadLength;                           // get the road length
   cin >> roadLength;

   cout << "Enter the number of points at which hill elevation "
           "was measured: ";
   int numPoints;
   cin >> numPoints;

   cout << "Enter the hill elevations (y values) at the " << numPoints 
        << " equally-spaced points.\n  The amount of dirt to be removed"
           " from the hill will be computed.\n\n";

                                               // compute X-sect. area
   double hillCrossSectionalArea
                           = trapezoidalArea(numPoints-1, roadLength);
   cout << "Enter the width of the roadway: ";
   double roadWidth;                           // get the road width
   cin >> roadWidth;
                                               // compute volume
   double dirtVolume = roadWidth * hillCrossSectionalArea;
                                               // display volume
   cout << "\n The volume of dirt to be removed is approximately "
        << dirtVolume << " cubic units." << endl;
}

/*** Insert definition of the function trapezoidalArea()
     from POP 8-1 here. ***/
     
/* trapezoidalArea computes the approximate area under a curve
 * for which a collection of y values at equally spaced x values
 * are entered from the keyboard.
 * 
 *   Receive:      n, number of subintervals along the x axis
 *                 intLength, length of the interval on the x axis
 *   Precondition: The y values correspond to equally-spaced 
 *                 x-values in the interval on the x axis.
 *   Return:       the approximate area under the curve
 ****************************************************************/

double trapezoidalArea(int n, double intLength)
{
   double yValue;
   cout << "First y value? ";
   cin >> yValue;                         // the first y value
   double sum = yValue / 2.0;             // start sum at 1st term in
                                          //  the trap. formula
   for (int i = 1; i <= n - 1; i++) 
   {
      cout << "Next y value?  ";;
      cin >> yValue;                      // i-th y value
      sum += yValue;                      // add it to sum
   }

   cout << "Last y value?  ";
   cin >> yValue;                         // the last y value
   sum += yValue/ 2.0;                    // add 1/2 of it to sum

   double deltaX = intLength / double(n);

   return deltaX * sum;                   // total area of trapezoids
}